使用require时如何解决命名空间冲突-问答-阿里云开发者社区-阿里云

开发者社区> 问答> 正文

使用require时如何解决命名空间冲突

小旋风柴进 2016-05-31 11:37:32 1448

最近在尝试require,但是在使用过程中发现有问题。
就是不知道如何解决命名空间冲突的问题。
举一个简单的例子:
JqueryUI中有tooltip,bootstrap里面也有,而基于某种特殊的原因,要把这两个框架都使用在同一个页面中。
普通(非模块化)的方法很好解决:

<script src="jquery-ui/jquery-ui.min.js" type="text/javascript"></script>
<script>
$.widget.bridge('uitooltip', $.ui.tooltip);  //重命名tooltip为uitooltip
</script>
<script src="bootstrap.min.js" type="text/javascript"></script>

但是使用require就不知道如何解决命名空间冲突了:

require.config({
    paths: {
        'jquery': 'jquery.min',
        'bootstrap': 'bootstrap',
        'jqueryUI': 'jquery-ui/jquery-ui.min'
    },
    shim: {
        'bootstrap': {
            deps: ['jquery'],
            exports: 'bs'
        },
        'jqueryUI': {
            deps: ['jquery'],
            exports: 'jqUI'
        }
    }
});
require(['jquery','jqueryUI','bootstrap'], function (){
    $(function(){
        $.widget.bridge('uitooltip', $.ui.tooltip);
        $('#a').uitooltip();    //使用jqui的tooltip装饰
        $('#b').tooltip();      //使用bootstrap的tooltip装饰
    });
});

试过调换require中获取顺序,也无法得到预期结果。
新学require,望各位帮帮忙。

前端开发 JavaScript
分享到
取消 提交回答
全部回答(1)
  • 小旋风柴进
    2019-07-17 19:21:42
    require.config({
        paths: {
            'jquery': '../jquery.min',
            'bootstrap': 'bootstrap',
            'jqueryUI': 'jquery-ui/jquery-ui.min'
        },
        shim: {
            'bootstrap': {
                deps: ['jquery','jqueryUI'],
            }
        }
    });
    require(['jquery','jqueryUI','bootstrap'], function (){
        $(function(){
            $.widget.bridge('uitooltip', $.ui.tooltip);
            $('#a').uitooltip();
            $('#b').tooltip();
        });
    0 0
开发与运维
使用钉钉扫一扫加入圈子
+ 订阅

集结各类场景实战经验,助你开发运维畅行无忧

推荐文章
相似问题
推荐课程